truelist = NULL;
max_iter = 100;
for( iter in 1:max_iter ){
 tempn = n;    # Temporarily set aside the sample size
 n = 1000000;  # Sample size used for MC estimation of the true parameters
 source("code_generate_data.r");
 trueQY = matrix(quantile(Y,p=taulist),1,);
 source("code_kernel.r");
 bandwidth = 1.06 * sd(Y) / n^0.2;
 truefY = matrix(0,1,length(taulist));
 truetheta = matrix(0,1,length(taulist));
 trueUQPE = matrix(0,1,length(taulist));
 for( tdx in 1:(length(taulist)) ){
  truefY[,tdx] = colSums( kernel( ( Y - trueQY[,tdx] ) / bandwidth ) ) / ( n * bandwidth );
  truetheta[,tdx] = mean( -1 * gprime(X1) * dnorm( trueQY[,tdx] - g(X1) - X2p %*% para_alpha ) )
  trueUQPE[,tdx] = -1 * truetheta[,tdx] / truefY[,tdx];
 }
 rm(Y); rm(X1); rm(X2p); gc();
 n = tempn;
 truelist = rbind( truelist, cbind( trueQY, truefY, truetheta, trueUQPE ) );
 if( floor(iter/max_iter*10) == iter/max_iter*10 ){
  print(paste("Approximating true parameter values: ",100*iter/max_iter,"%",sep=""));
  Sys.sleep(0.01);
  flush.console();
 }
}
trueQY = colMeans(truelist)[1:length(taulist)+0*length(taulist)];
truefY = colMeans(truelist)[1:length(taulist)+1*length(taulist)];
truetheta = colMeans(truelist)[1:length(taulist)+2*length(taulist)];
trueUQPE = colMeans(truelist)[1:length(taulist)+3*length(taulist)];