################################################################################
# DATA GENERATING PARAMETERS (BEGIN)
################################################################################
N = 500000
################################################################################
# DATA GENERATING PARAMETERS (ENDED)
################################################################################

cl<-makeCluster(1)
registerDoParallel(cl)
trueUQPE <- foreach( bdx = 1:15, .combine = cbind )%dopar%{
library(mvtnorm)
library(glmnet)
################################################################################
# GENERATE DATA (BEGIN)
################################################################################
X2p = rmvnorm(N, mean=rep(0,nrow(Sigma)), sigma=Sigma)
X1  = matrix(rnorm(N, mean=(X2p%*%gamma), sd=1),N,1)
Y = matrix(rnorm(N, mean=(g(X1)+X2p%*%alpha), sd=1),N,1)
################################################################################
# GENERATE DATA (ENDED)
################################################################################

################################################################################
# ESTIMATE m0 & m1 (BEGIN)
################################################################################
m0hat = matrix(0,N,dim(taulist)[1])
m1hat = matrix(0,N,dim(taulist)[1])
bX = b(cbind(X1,X1^2,X1^3,X2p,X2p^2,X2p^3))
bXsd = apply(bX,2,sd); bXsd[which(bXsd==0)]=1; bXsd = t(matrix(bXsd,dim(bX)[2],N))
bX = bX / bXsd
lambda = 1.1*qnorm(1-0.1/log(N)/max(c(dim(bX)[2],N)))/N^0.5

for( idx in 1:(dim(taulist)[1]) ){
 tau = taulist[idx,1]
 qhattau = quantile(Y,p=tau)

 # LASSO #
 Psihat = colMeans( matrix(Y<=qhattau,N,dim(bX)[2])^2 * bX^2 )^0.5
 lassoresult = glmnet( bX, Y<=qhattau, lambda = lambda, family = "binomial", intercept = TRUE, penalty.factor = Psihat );
 mcheck = cbind(1,bX) %*% coef(lassoresult)
 Psihat = colMeans( matrix(Y<=qhattau-mcheck,N,dim(bX)[2])^2 * bX^2 )^0.5
 lassoresult = glmnet( bX, Y<=qhattau, lambda = lambda, family = "binomial", intercept = TRUE, penalty.factor = Psihat )

 # POST LASSO #
 support = which( as.numeric(coef(lassoresult))[2:(dim(bX)[2]+1)] | 1:(dim(bX)[2])<=3 )
 selected_bX = matrix(bX[,support],N,length(support))
 postlassoresult = glm( (Y<=qhattau) ~ selected_bX, family = "binomial" )
 postlasscoef = matrix(0,dim(bX)[2]+1,1)
 postlasscoef[c(1,support+1)] = coef(postlassoresult)
 postlasscoef[which(is.na(postlasscoef))] = 0

 # m0 & m1 #
 m0hat[,idx] = plogis( cbind(1,bX) %*% postlasscoef )
 m1hat[,idx] = dlogis( cbind(1,bX) %*% postlasscoef ) * cbind(0,(b(cbind(X1+DELTA,(X1+DELTA)^2,(X1+DELTA)^3,X2p,X2p^2,X2p^3))/bXsd-bX)) %*% postlasscoef / DELTA
}
################################################################################
# ESTIMATE m0 & m1 (ENDED)
################################################################################

################################################################################
# ESTIMATE \omega (BEGIN)
################################################################################
# COODINATE DESCEND OBJECTIVE FUNCTION
#subobj <- function(rho1,rho,coord,Mhat,Ghat,lambdaL){ 
# rho[cood,1]=rho1; return( -2*t(Mhat)%*%rho + t(rho)%*%Ghat%*%rho + 2*lambdaL*sum(abs(rho)) ) 
#}
#
#hX = h(cbind(X1,X1^2,X1^3,X2p,X2p^2,X2p^3))
#hXsd = apply(hX,2,sd); hXsd[which(hXsd==0)]=1; hXsd = t(matrix(hXsd,dim(hX)[2],N))
#hX = hX / hXsd
#dimhX = dim(hX)[2]
#Mhat = matrix(-colMeans( (h(cbind(X1+DELTA,(X1+DELTA)^2,(X1+DELTA)^3,X2p,X2p^2,X2p^3)) / hXsd-hX)/DELTA ),,1)
#Ghat = t(hX)%*%hX / N
#
#lambdaL = log(log(N))*(log(dim(hX)[2])/N)^0.5 ### TO MAKE IT MORE DATA-DRIVEN LATER
#rho = matrix(0,dimhX,1); prevrho = rho; DONE = FALSE
#it = 1
#while( !DONE & it < 100 ){
# for( cood in 1:(dim(rho)[1]) ){
#  rho[cood,1] = nlm(subobj,rho[cood,1],rho,cood,Mhat,Ghat,lambdaL)$estimate
# }
# DONE = sum((rho-prevrho)^2)^0.5 < TOLERANCE; prevrho = rho;  it = it + 1;
#}
omegahat = 0 #hX%*%rho
################################################################################
# ESTIMATE \omega (ENDED)
################################################################################

################################################################################
# ESTIMATE \theta (BEGIN)
################################################################################
thetahat = matrix( colMeans( m1hat - matrix(omegahat,N,length(taulist)) * ( ( matrix(Y,N,length(taulist)) <= t(matrix(quantile(Y,p=taulist),length(taulist),N)) ) - m0hat ) ), length(taulist), 1)
################################################################################
# ESTIMATE \theta (ENDED)
################################################################################

################################################################################
# ESTIMATE DENSITY (BEGIN)
################################################################################
K1 <- function(u){ return(0.75*(1-u^2)*(-1 < u)*(u < 1)) }
h1 = 1.06 * sd(Y) / N^0.2 / N^0.01;
fhat = matrix(0,length(taulist),1)
for( idx in 1:length(taulist) ){
 fhat[idx] = mean(K1((Y-quantile(Y,p=taulist[idx]))/h1)/h1)
}
################################################################################
# ESTIMATE DENSITY (ENDED)
################################################################################

################################################################################
# ESTIMATE UQPE (BEGIN)
################################################################################
trueUQPE = - thetahat / fhat
################################################################################
# ESTIMATE UQPE (ENDED)
################################################################################

rm(X2p);rm(X1);rm(Y);rm(m0hat);rm(m1hat);rm(bX);rm(bXsd);rm(hX);rm(hXsd);rm(Mhat);rm(Ghat);rm(rho);rm(fhat);gc();
trueUQPE
}
stopCluster(cl)

trueUQPE = matrix(rowMeans(trueUQPE),,1)
