################################################################################
# INSTALL PACKAGES AND CALL LIBRARIES
################################################################################
list.of.packages <- c("mvtnorm","glmnet","doParallel")
new.packages <- list.of.packages[!(list.of.packages %in% installed.packages()[,"Package"])]
if(length(new.packages)) install.packages(new.packages)
library(glmnet);
library(hqreg);
library(doParallel)

################################################################################
# BASIC SETTINGS
################################################################################
DELTA = 0.0000001
TOLERANCE = 0.001
taulist = matrix(10:40/50,,1)
B = 500
PARALLEL = 4

################################################################################
# DATA
################################################################################
load("data.RData");
head(y); # days_per_week hours_per_day hours_per_week hourly_wage weekly_earn
head(d); # jc_days class_days
y = matrix(y[,"hourly_wage"],,1)
d1 = matrix(d[,"jc_days"],,1)
d2 = matrix(d[,"class_days"],,1)
data <- cbind(y,d1,d2,x);
data <- na.omit(data);
N = dim(data)[1]; 
p = dim(data)[2]-3;
Y = matrix(data[,1],,1);
#Y = log(Y);
X1 = matrix(data[,2],,1);   # '2' for "jc_days" and '3' for "class_days"
X2p = as.matrix(data[,4:(dim(data)[2])])

#X2p_int = NULL;
#for( idx in 1:(dim(X2p)[2]) ){
# for( jdx in 1:(dim(X2p)[2]) ){
#  if( idx != jdx ){
#   X2p_int = cbind(X2p_int,X2p[,idx]*(X2p[,jdx]>median(X2p[,jdx])))
#  }
# }
#}
#X2p = cbind(X2p,X2p_int)

for( idx in 1:(dim(X2p)[2]) ){
 if( sd(X2p[,idx])>0 ){ 
  X2p[,idx] = (X2p[,idx]-mean(X2p[,idx]))/sd(X2p[,idx])
 }
}
p = dim(X2p)[2]

################################################################################
# ESTIMATION PARAMETERS (BEGIN)
################################################################################
taulist = matrix(10:40/50,,1)
b <- function(x){ cbind(x,x^2,x^3) }
h <- function(x){ cbind(x,x^2,x^3,1) }
################################################################################
# ESTIMATION PARAMETERS (ENDED)
################################################################################

################################################################################
# MODEL SELECTION FOR ESTIMATION OF m0 & m1 (BEGIN)
################################################################################
lassoestimates = NULL
bX = b(cbind(X1,X1^2,X1^3,X2p,X2p^2,X2p^3))
bXsd = apply(bX,2,sd); bXsd[which(bXsd==0)]=1; bXsd = t(matrix(bXsd,dim(bX)[2],N))
bX = bX / bXsd
lambda = 1.1*qnorm(1-0.1/log(N)/max(c(dim(bX)[2],N)))/N^0.5

for( idx in c(1,11,21,31) ){
 tau = taulist[idx,1]
 qhattau = quantile(Y,p=tau)

 # LASSO #
 Psihat = colMeans( matrix(Y<=qhattau,N,dim(bX)[2])^2 * bX^2 )^0.5 + 0.00001
 lassoresult = glmnet( bX, Y<=qhattau, lambda = lambda, family = "binomial", intercept = TRUE, penalty.factor = Psihat );
 mcheck = cbind(1,bX) %*% coef(lassoresult)
 Psihat = colMeans( matrix(Y<=qhattau-mcheck,N,dim(bX)[2])^2 * bX^2 )^0.5 + 0.00001
 lassoresult = glmnet( bX, Y<=qhattau, lambda = lambda, family = "binomial", intercept = TRUE, penalty.factor = Psihat )
 lassoestimates = cbind(lassoestimates,coef(lassoresult))
}
################################################################################
# MODEL SELECTION FOR ESTIMATION OF m0 & m1 (ENDED)
################################################################################
lassoestimates 